
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Poppler.Objects.AnnotScreen
    ( 

-- * Exported types
    AnnotScreen(..)                         ,
    AnnotScreenK                            ,
    toAnnotScreen                           ,
    noAnnotScreen                           ,


 -- * Methods
-- ** annotScreenGetAction
    annotScreenGetAction                    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Poppler.Types
import GI.Poppler.Callbacks
import qualified GI.GObject as GObject

newtype AnnotScreen = AnnotScreen (ForeignPtr AnnotScreen)
foreign import ccall "poppler_annot_screen_get_type"
    c_poppler_annot_screen_get_type :: IO GType

type instance ParentTypes AnnotScreen = AnnotScreenParentTypes
type AnnotScreenParentTypes = '[Annot, GObject.Object]

instance GObject AnnotScreen where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_poppler_annot_screen_get_type
    

class GObject o => AnnotScreenK o
instance (GObject o, IsDescendantOf AnnotScreen o) => AnnotScreenK o

toAnnotScreen :: AnnotScreenK o => o -> IO AnnotScreen
toAnnotScreen = unsafeCastTo AnnotScreen

noAnnotScreen :: Maybe AnnotScreen
noAnnotScreen = Nothing

type instance AttributeList AnnotScreen = AnnotScreenAttributeList
type AnnotScreenAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList AnnotScreen = AnnotScreenSignalList
type AnnotScreenSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method AnnotScreen::get_action
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "AnnotScreen", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "AnnotScreen", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Poppler" "Action"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_annot_screen_get_action" poppler_annot_screen_get_action :: 
    Ptr AnnotScreen ->                      -- _obj : TInterface "Poppler" "AnnotScreen"
    IO (Ptr Action)


annotScreenGetAction ::
    (MonadIO m, AnnotScreenK a) =>
    a ->                                    -- _obj
    m Action
annotScreenGetAction _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- poppler_annot_screen_get_action _obj'
    checkUnexpectedReturnNULL "poppler_annot_screen_get_action" result
    result' <- (newBoxed Action) result
    touchManagedPtr _obj
    return result'


