
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Poppler.Structs.ActionNamed
    ( 

-- * Exported types
    ActionNamed(..)                         ,
    noActionNamed                           ,


 -- * Properties
-- ** NamedDest
    actionNamedReadNamedDest                ,


-- ** Title
    actionNamedReadTitle                    ,


-- ** Type
    actionNamedReadType                     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Poppler.Types
import GI.Poppler.Callbacks

newtype ActionNamed = ActionNamed (ForeignPtr ActionNamed)
noActionNamed :: Maybe ActionNamed
noActionNamed = Nothing

actionNamedReadType :: ActionNamed -> IO ActionType
actionNamedReadType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

actionNamedReadTitle :: ActionNamed -> IO T.Text
actionNamedReadTitle s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

actionNamedReadNamedDest :: ActionNamed -> IO T.Text
actionNamedReadNamedDest s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'


