
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Poppler.Structs.ActionUri
    ( 

-- * Exported types
    ActionUri(..)                           ,
    noActionUri                             ,


 -- * Properties
-- ** Title
    actionUriReadTitle                      ,


-- ** Type
    actionUriReadType                       ,


-- ** Uri
    actionUriReadUri                        ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Poppler.Types
import GI.Poppler.Callbacks

newtype ActionUri = ActionUri (ForeignPtr ActionUri)
noActionUri :: Maybe ActionUri
noActionUri = Nothing

actionUriReadType :: ActionUri -> IO ActionType
actionUriReadType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

actionUriReadTitle :: ActionUri -> IO T.Text
actionUriReadTitle s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

actionUriReadUri :: ActionUri -> IO T.Text
actionUriReadUri s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'


