
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Poppler.Structs.LayersIter
    ( 

-- * Exported types
    LayersIter(..)                          ,
    noLayersIter                            ,


 -- * Methods
-- ** layersIterCopy
    layersIterCopy                          ,


-- ** layersIterFree
    layersIterFree                          ,


-- ** layersIterGetChild
    layersIterGetChild                      ,


-- ** layersIterGetLayer
    layersIterGetLayer                      ,


-- ** layersIterGetTitle
    layersIterGetTitle                      ,


-- ** layersIterNew
    layersIterNew                           ,


-- ** layersIterNext
    layersIterNext                          ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Poppler.Types
import GI.Poppler.Callbacks

newtype LayersIter = LayersIter (ForeignPtr LayersIter)
foreign import ccall "poppler_layers_iter_get_type" c_poppler_layers_iter_get_type :: 
    IO GType

instance BoxedObject LayersIter where
    boxedType _ = c_poppler_layers_iter_get_type

noLayersIter :: Maybe LayersIter
noLayersIter = Nothing

-- method LayersIter::new
-- method type : Constructor
-- Args : [Arg {argName = "document", argType = TInterface "Poppler" "Document", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "document", argType = TInterface "Poppler" "Document", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Poppler" "LayersIter"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_new" poppler_layers_iter_new :: 
    Ptr Document ->                         -- document : TInterface "Poppler" "Document"
    IO (Ptr LayersIter)


layersIterNew ::
    (MonadIO m, DocumentK a) =>
    a ->                                    -- document
    m LayersIter
layersIterNew document = liftIO $ do
    let document' = unsafeManagedPtrCastPtr document
    result <- poppler_layers_iter_new document'
    checkUnexpectedReturnNULL "poppler_layers_iter_new" result
    result' <- (wrapBoxed LayersIter) result
    touchManagedPtr document
    return result'

-- method LayersIter::copy
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Poppler" "LayersIter"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_copy" poppler_layers_iter_copy :: 
    Ptr LayersIter ->                       -- _obj : TInterface "Poppler" "LayersIter"
    IO (Ptr LayersIter)


layersIterCopy ::
    (MonadIO m) =>
    LayersIter ->                           -- _obj
    m LayersIter
layersIterCopy _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- poppler_layers_iter_copy _obj'
    checkUnexpectedReturnNULL "poppler_layers_iter_copy" result
    result' <- (wrapBoxed LayersIter) result
    touchManagedPtr _obj
    return result'

-- method LayersIter::free
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_free" poppler_layers_iter_free :: 
    Ptr LayersIter ->                       -- _obj : TInterface "Poppler" "LayersIter"
    IO ()


layersIterFree ::
    (MonadIO m) =>
    LayersIter ->                           -- _obj
    m ()
layersIterFree _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    poppler_layers_iter_free _obj'
    touchManagedPtr _obj
    return ()

-- method LayersIter::get_child
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Poppler" "LayersIter"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_get_child" poppler_layers_iter_get_child :: 
    Ptr LayersIter ->                       -- _obj : TInterface "Poppler" "LayersIter"
    IO (Ptr LayersIter)


layersIterGetChild ::
    (MonadIO m) =>
    LayersIter ->                           -- _obj
    m LayersIter
layersIterGetChild _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- poppler_layers_iter_get_child _obj'
    checkUnexpectedReturnNULL "poppler_layers_iter_get_child" result
    result' <- (wrapBoxed LayersIter) result
    touchManagedPtr _obj
    return result'

-- method LayersIter::get_layer
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Poppler" "Layer"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_get_layer" poppler_layers_iter_get_layer :: 
    Ptr LayersIter ->                       -- _obj : TInterface "Poppler" "LayersIter"
    IO (Ptr Layer)


layersIterGetLayer ::
    (MonadIO m) =>
    LayersIter ->                           -- _obj
    m Layer
layersIterGetLayer _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- poppler_layers_iter_get_layer _obj'
    checkUnexpectedReturnNULL "poppler_layers_iter_get_layer" result
    result' <- (wrapObject Layer) result
    touchManagedPtr _obj
    return result'

-- method LayersIter::get_title
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_get_title" poppler_layers_iter_get_title :: 
    Ptr LayersIter ->                       -- _obj : TInterface "Poppler" "LayersIter"
    IO CString


layersIterGetTitle ::
    (MonadIO m) =>
    LayersIter ->                           -- _obj
    m T.Text
layersIterGetTitle _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- poppler_layers_iter_get_title _obj'
    checkUnexpectedReturnNULL "poppler_layers_iter_get_title" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method LayersIter::next
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Poppler" "LayersIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "poppler_layers_iter_next" poppler_layers_iter_next :: 
    Ptr LayersIter ->                       -- _obj : TInterface "Poppler" "LayersIter"
    IO CInt


layersIterNext ::
    (MonadIO m) =>
    LayersIter ->                           -- _obj
    m Bool
layersIterNext _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- poppler_layers_iter_next _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'


